Loading...
Searching...
No Matches
BALL::ScoringComponent Class Reference

`#include <BALL/SCORING/COMMON/scoringComponent.h>`

Inheritance diagram for BALL::ScoringComponent:

## Public Member Functions

| ScoringComponent ()
| ScoringComponent (const ScoringComponent &sc)
| ScoringComponent (ScoringFunction &sf)
void | selectBaseFunction (String function)
virtual | ~ScoringComponent ()
virtual void | clear ()
virtual bool | setup ()
virtual void | setupLigand ()
ScoringFunction * | getScoringFunction () const
void | setScoringFunction (ScoringFunction &sf)
String | getName () const
void | setName (const String &name)
const String & | getTypeName ()
double | getRawScore () const
double | getScaledScore () const
virtual void | update (const vector< std::pair< Atom *, Atom * > > &pair_vector)
virtual double | updateScore ()
virtual void | setLigandIntraMolecular (bool b)
bool | isLigandIntraMolecular ()
bool | isGridable ()
bool | isAtomPairwise ()
void | setCoefficient (const double &coeff)
const double & | getCoefficient ()
void | setNormalizationParameters (double stddev, double mean)
void | getNormalizationParameters (double &stddev, double &mean)
bool | isEnabled ()
void | enable ()
void | disable ()

## Protected Member Functions

double | scaleScore (double score) const

## Protected Attributes

bool | ligand_intra_molecular_
bool | gridable_
bool | atom_pairwise_
ScoringFunction * | scoring_function_
ScoringBaseFunction * | base_function_
double | score_
double | coefficient_
double | stddev_
double | mean_
bool | enabled_
String | type_name_

## Detailed Description

Definition at line 20 of file scoringComponent.h.

## Constructor & Destructor Documentation

## ScoringComponent() [1/3]

BALL::ScoringComponent::ScoringComponent | ( |  | ) |

## ScoringComponent() [2/3]

BALL::ScoringComponent::ScoringComponent | ( | const ScoringComponent & | sc | ) |

## ScoringComponent() [3/3]

BALL::ScoringComponent::ScoringComponent | ( | ScoringFunction & | sf | ) |

## ~ScoringComponent()

virtual BALL::ScoringComponent::~ScoringComponent | ( |  | ) |

virtual

## Member Function Documentation

## clear()

virtual void BALL::ScoringComponent::clear | ( |  | ) |

virtual

Reimplemented in BALL::AmberNonBonded, BALL::AromaticRingStacking, BALL::BuriedPolar, BALL::CharmmNonBonded, BALL::CHPI, BALL::CHPISlick, BALL::HydrogenBond, BALL::HydrogenBondSlick, BALL::Lipophilic, BALL::MMFF94NonBonded, BALL::NonpolarSolvation, BALL::PLP, BALL::Polarity, BALL::PolarSolvation, and BALL::VanDerWaalsSlick.

## disable()

void BALL::ScoringComponent::disable | ( |  | ) |

## enable()

void BALL::ScoringComponent::enable | ( |  | ) |

## getCoefficient()

const double & BALL::ScoringComponent::getCoefficient | ( |  | ) |

## getName()

String BALL::ScoringComponent::getName | ( |  | ) | const

## getNormalizationParameters()

void BALL::ScoringComponent::getNormalizationParameters | ( | double & | stddev,
|  | double & | mean )

## getRawScore()

double BALL::ScoringComponent::getRawScore | ( |  | ) | const

## getScaledScore()

double BALL::ScoringComponent::getScaledScore | ( |  | ) | const

## getScoringFunction()

ScoringFunction * BALL::ScoringComponent::getScoringFunction | ( |  | ) | const

## getTypeName()

const String & BALL::ScoringComponent::getTypeName | ( |  | ) |

## isAtomPairwise()

bool BALL::ScoringComponent::isAtomPairwise | ( |  | ) |

Does this component calculate the score based on atom-atom pairs?

## isEnabled()

bool BALL::ScoringComponent::isEnabled | ( |  | ) |

## isGridable()

bool BALL::ScoringComponent::isGridable | ( |  | ) |

Can the scores of this ScoringFunction be precomputed for a grid?

## isLigandIntraMolecular()

bool BALL::ScoringComponent::isLigandIntraMolecular | ( |  | ) |

Is this ScoringComponent to be used to calculate an intra-molecular score for the ligand ?

## scaleScore()

double BALL::ScoringComponent::scaleScore | ( | double | score | ) | const

protected

Multiplies the score_ with coefficient_ and, if necessary, does transformation and backtransformation.

## selectBaseFunction()

void BALL::ScoringComponent::selectBaseFunction | ( | String | function | ) |

select the base function (necessary only if the specific ScoringComponent uses it). Possible choices are 'fermi' and 'linear'.

## setCoefficient()

void BALL::ScoringComponent::setCoefficient | ( | const double & | coeff | ) |

## setLigandIntraMolecular()

virtual void BALL::ScoringComponent::setLigandIntraMolecular | ( | bool | b | ) |

virtual

Reimplemented in BALL::RotationalEntropy.

## setName()

void BALL::ScoringComponent::setName | ( | const String & | name | ) |

## setNormalizationParameters()

void BALL::ScoringComponent::setNormalizationParameters | ( | double | stddev,
|  | double | mean )

## setScoringFunction()

void BALL::ScoringComponent::setScoringFunction | ( | ScoringFunction & | sf | ) |

## setup()

virtual bool BALL::ScoringComponent::setup | ( |  | ) |

virtual

Reimplemented in BALL::AmberBend, BALL::AmberNonBonded, BALL::AmberStretch, BALL::AmberTorsion, BALL::BuriedPolar, BALL::CharmmBend, BALL::CharmmImproperTorsion, BALL::CharmmNonBonded, BALL::CharmmStretch, BALL::CharmmTorsion, BALL::CHPI, BALL::CHPISlick, BALL::ForceFieldComponent, BALL::HydrogenBond, BALL::HydrogenBondSlick, BALL::Lipophilic, BALL::MMFF94NonBonded, BALL::MMFF94OutOfPlaneBend, BALL::MMFF94StretchBend, BALL::MMFF94Torsion, BALL::NonpolarSolvation, BALL::Polarity, BALL::PolarSolvation, and BALL::VanDerWaalsSlick.

## setupLigand()

virtual void BALL::ScoringComponent::setupLigand | ( |  | ) |

virtual

Function that needs to be called once for every new ligand.
The default implementation of this base class does nothing and should be overloaded by derived classes if necessary.

Reimplemented in BALL::AromaticRingStacking, BALL::BuriedPolar, BALL::CHPI, BALL::HydrogenBond, BALL::Lipophilic, BALL::PB, and BALL::Polarity.

## update()

virtual void BALL::ScoringComponent::update | ( | const vector< std::pair< Atom *, Atom * > > & | pair_vector | ) |

virtual

Update this ScoringComponent using the given atom-pairs.
This function should be overloaded by all ScoringComponents

Reimplemented in BALL::AmberNonBonded, BALL::AromaticRingStacking, BALL::BurialDepth, BALL::BuriedPolar, BALL::CHPI, BALL::CHPISlick, BALL::Electrostatic, BALL::HydrogenBond, BALL::HydrogenBondSlick, BALL::NonpolarSolvation, BALL::PB, BALL::PLP, BALL::Polarity, BALL::PolarSolvation, BALL::RotationalEntropy, BALL::VanDerWaals, and BALL::VanDerWaalsSlick.

## updateScore()

virtual double BALL::ScoringComponent::updateScore | ( |  | ) |

virtual

Calculate the score for this component (for all interactions that have been set by the last call of update()) and return the score.
The coefficient assigned by the user to this component should be taken into account for the calculation, so that the weighted score is returned.

Reimplemented in BALL::AromaticRingStacking, BALL::BurialDepth, BALL::BuriedPolar, BALL::CHPI, BALL::CHPISlick, BALL::Electrostatic, BALL::ForceFieldComponent, BALL::FragmentationalSolvation, BALL::HydrogenBond, BALL::HydrogenBondSlick, BALL::Lipophilic, BALL::NonpolarSolvation, BALL::PB, BALL::Polarity, BALL::PolarSolvation, BALL::RotationalEntropy, BALL::Solvation, BALL::VanDerWaals, and BALL::VanDerWaalsSlick.

## Member Data Documentation

## atom_pairwise_

bool BALL::ScoringComponent::atom_pairwise_

protected

Does this component calculate the score based on atom-atom pairs?

Definition at line 106 of file scoringComponent.h.

## base_function_

ScoringBaseFunction* BALL::ScoringComponent::base_function_

protected

Definition at line 110 of file scoringComponent.h.

## coefficient_

double BALL::ScoringComponent::coefficient_

protected

Definition at line 114 of file scoringComponent.h.

## enabled_

bool BALL::ScoringComponent::enabled_

protected

Determines whether this ScoringComponent is enabled and should be used when ScoringFunction::update()/updateScore() is called.

Definition at line 127 of file scoringComponent.h.

## gridable_

bool BALL::ScoringComponent::gridable_

protected

Can the scores of this ScoringFunction be precomputed for a grid?

Definition at line 101 of file scoringComponent.h.

## ligand_intra_molecular_

bool BALL::ScoringComponent::ligand_intra_molecular_

protected

Is this ScoringComponent to be used to calculate an intra-molecular score for the ligand?

Definition at line 96 of file scoringComponent.h.

## mean_

double BALL::ScoringComponent::mean_

protected

Definition at line 117 of file scoringComponent.h.

## score_

double BALL::ScoringComponent::score_

protected

Definition at line 112 of file scoringComponent.h.

## scoring_function_

ScoringFunction* BALL::ScoringComponent::scoring_function_

protected

Definition at line 108 of file scoringComponent.h.

## stddev_

double BALL::ScoringComponent::stddev_

protected

Definition at line 116 of file scoringComponent.h.

## type_name_

String BALL::ScoringComponent::type_name_

protected

An abreviation for the type of this ScoringComponent, i.e.: 'ES', 'vdW', 'fragSolv', 'nRot', 'HB'.
This type-name cannot be changed dynmically and is used to differentiate between the differnt types of ScoringComponents as is necessary e.g. for PharmacophoreConstraints.

Definition at line 135 of file scoringComponent.h.